/* XulCheckBox.java */
package org.jxul.framework;

import java.io.*;
import javax.swing.*;

import org.w3c.dom.*;

import org.jxul.util.*;

/**
 * A XUL CheckBox.
 */
public class XulCheckBox extends JCheckBox
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }
    
    private Element checkBoxElement;
    // attributes
    String style;
    String label;
    String accesskey;
    String disabled;
    String oncommand;                                                  
    String id;
    String _class;
    boolean checked;
    String crop;
    String imgalign;
    String src;
         
    public XulCheckBox(Element checkBoxElement)
    {
        this.checkBoxElement = checkBoxElement;

        Attr labelAttr = checkBoxElement.getAttributeNode(XulSyntax.CHECKBOX_ATTR_LABEL);
        if (labelAttr != null)
        {
            label = labelAttr.getNodeValue();
            if (label != null && !StringUtil.isBlank(label))
                this.setText(label);
        }

        Attr accesskeyAttr = checkBoxElement.getAttributeNode(XulSyntax.CHECKBOX_ATTR_ACCESSKEY);

        Attr disabledAttr = checkBoxElement.getAttributeNode(XulSyntax.CHECKBOX_ATTR_DISABLED);
        if (disabledAttr != null)
        {
            disabled = disabledAttr.getNodeValue();
            if (disabled.equals(XulSyntax.CHECKBOX_ATTR_DISABLED_TRUE))
                this.setEnabled(false);
            else    
                this.setEnabled(true);
        }

        Attr oncommandAttr = checkBoxElement.getAttributeNode(XulSyntax.CHECKBOX_ATTR_ONCOMMAND);

        Attr idAttr = checkBoxElement.getAttributeNode(XulSyntax.CHECKBOX_ATTR_ID);

        Attr _classAttr = checkBoxElement.getAttributeNode(XulSyntax.CHECKBOX_ATTR_CLASS);

        Attr checkedAttr = checkBoxElement.getAttributeNode(XulSyntax.CHECKBOX_ATTR_CHECKED);
        if (checkedAttr != null)
        {
            String sChecked = checkedAttr.getNodeValue();
            if (sChecked != null && sChecked.length() > 0)
            {
                if (sChecked.equals(XulSyntax.CHECKBOX_ATTR_CHECKED_TRUE))
                {
                    checked = true;
                    this.setSelected(checked);
                }
                else
                {
                    checked = false;    
                }
            }
        }
        
        Attr cropAttr = checkBoxElement.getAttributeNode(XulSyntax.CHECKBOX_ATTR_CROP);

        Attr imgalignAttr = checkBoxElement.getAttributeNode(XulSyntax.CHECKBOX_ATTR_IMGALIGN);

        Attr srcAttr = checkBoxElement.getAttributeNode(XulSyntax.CHECKBOX_ATTR_SRC);
        
    }
    
    /** for unit testing. */
    public static void main(String args[])
    {
        try
        {
            
        } catch (Throwable t)
          {
            t.printStackTrace();
          }
    }
}
