/* XulProgressMeter.java */
package org.jxul.framework;

import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import java.net.*;
import java.util.*;

import org.w3c.dom.*;

import org.jxul.util.*;
import org.jxul.css.*;
import org.jxul.js.*;

/**
 *
 * <P>
 *   A XUL Progress Meter
 * </P>
 * @author Seor Vaughn Bullard
 * @version 0.1
 */

 /*
  * A XUL Progress Meter.
  */
public class XulProgressMeter extends JProgressBar implements ActionListener
{
    public static final boolean debug;

    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }

    private XulJsEngine jsEngine = null;
    private Element progressMeterElement;
    private String jsFunction = null;

    // attributes

    String orient;
    String value;
    int pmVal;
	String label;
    String style;

    Style cssStyle;
    Hashtable peerMap;


    public XulProgressMeter(Element progressMeterElement, Hashtable peerMap) throws XulFormatException
    {
        this.progressMeterElement = progressMeterElement;

        // TBD: process all attributes

		Attr orientAttr		= progressMeterElement.getAttributeNode(XulSyntax.ATTR_ORIENT);
        Attr valueAttr 		= progressMeterElement.getAttributeNode(XulSyntax.PROGRESSMETER_ATTR_VALUE);
        Attr labelAttr		= progressMeterElement.getAttributeNode(XulSyntax.ATTR_LABEL);
        Attr styleAttr 		= progressMeterElement.getAttributeNode(XulSyntax.ATTR_STYLE);

        if (orientAttr != null)
        {
            orient = orientAttr.getNodeValue();

            // Defaults to horizontal orientation
            if(orient.equalsIgnoreCase("vertical"))
            	this.setOrientation(1);
            else
            	this.setOrientation(0);
        }else
         {
			this.setOrientation(0);
	 	 }

        if (valueAttr != null)
        {
            value = valueAttr.getNodeValue();
			pmVal = Integer.parseInt(value);
            this.setValue(pmVal);
        }else
         {
			this.setValue(0);
	 	 }

        if (labelAttr != null)
        {
            label = labelAttr.getNodeValue();
            this.setString(label);
			this.setStringPainted(true);
        }

        if (styleAttr != null)
        {
            // styling overriding the .css stylesheet
            style = styleAttr.getNodeValue();

            if (style != null && style.length() > 0)
            {
                // TBD:
                // create a CSS Style
                cssStyle = new Style(Style.NONAME,style);

                // apply it
                try
                {
                    cssStyle.apply(this);
                } catch (XulFormatException xfe)
                  {
                    xfe.printStackTrace();
                  }
            }
        }


    }
    public void actionPerformed(ActionEvent e)
    {
	if (jsFunction != null)
	{
		System.out.println("Need to execute " + jsFunction + " here!");
		jsEngine = XulJsEngine.getInstance();

		try
		{
			jsEngine.executeFunction(jsFunction);
		}
		catch (Exception jsexc)
		{
			jsexc.printStackTrace();
		}
	}
    }
    /** for unit testing. */
    public static void main(String args[])
    {
        try
        {

        } catch (Throwable t)
          {
            t.printStackTrace();
          }
    }
}
