/* XulTitledBox.java */
package org.jxul.framework;

import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;

import org.w3c.dom.*;

import org.jxul.util.*;

/**
 * A XUL Tab Control. 
 */
public class XulTabBox extends JPanel 
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }
    
    private Element tabsElement;
    // attributes
    XulTabs tabs;
    XulTabPanels tabPanels;
    Hashtable peerMap;
    
    public XulTabBox(Element tabsElement, Hashtable peerMap) throws XulFormatException
    {
        //super(tabsElement, peerMap);
        this.tabsElement = tabsElement;        
        this.peerMap = peerMap;
	processChildren();

    } // end of XulTitledBox Constructor
        
    // tab box has different children than
    // the box
    public void processChildren() throws XulFormatException
    {
        if (tabsElement.hasChildNodes())
        {
            /* children should be a set of widget elements 
               or more boxes. */
            NodeList children = tabsElement.getChildNodes();
            
            // iterate through each child, if a menu - create it
            int childCount = children.getLength();
            for (int i=0; i < childCount; i++)
            {
                // get the child node
                Node child = children.item(i);
                if (debug)
                     System.out.println("Child[" + i + "]" +
                     child.getNodeName() + "-" + child.getNodeValue());
 
                // switch on the type of the child
                
                if (child.getNodeName().equals(XulSyntax.ELEMENT_TABS))
                {
                    tabs = new XulTabs((Element)child, peerMap);
                    //if (cssStyle != null)
                    //    cssStyle.apply(tabs);
                    this.add(tabs);
                    peerMap.put(child, tabs);                    
                }
                else if (child.getNodeName().equals(XulSyntax.ELEMENT_TABPANELS))
                {
		    //ks - should be a no -op
                }
                
            } // end of for (all children)
        } // end of if (children exist)                       
    }
        
    /** for unit testing. */
    public static void main(String args[])
    {
        try
        {
            
        } catch (Throwable t)
          {
            t.printStackTrace();
          }
    }
}
