/* XulTreeCell.java */
package org.jxul.framework;

import java.io.*;
import java.util.*;
import org.w3c.dom.*;
import org.jxul.util.*;

/**
 * A XUL TreeCell which is a label
 */
public class XulTreeCell 
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }

    private Element treecellElement;
    
    // attributes
    String _class;
    String label;
    Hashtable peerMap;

    public XulTreeCell(Element treecellElement, Hashtable peerMap) throws XulFormatException
    {
        this.treecellElement = treecellElement; 
	this.peerMap = peerMap;

        Attr _classAttr = treecellElement.getAttributeNode(XulSyntax.ATTR_CLASS);
	Attr labelAttr = treecellElement.getAttributeNode(XulSyntax.ATTR_LABEL);
	if (labelAttr != null)
        {
		label = labelAttr.getNodeValue();
	}
	if (_classAttr != null)
	{
		_class = _classAttr.getNodeValue();
	}
    } // end of XulTreeCell Constructor

    public boolean isIndented()
    {
	return (_class != null && _class.equalsIgnoreCase(XulSyntax.TREECELL_CLASS_INDENT_VALUE));
    }
    
    public String getValue()
    {
	return (this.label);
    }
    /** for unit testing. */
    public static void main(String args[])
    {
        try
        {
            
        } catch (Throwable t)
          {
            t.printStackTrace();
          }
    }
}
