/* XulTreeChildren.java */
package org.jxul.framework;

import java.io.*;
import java.util.*;
import org.w3c.dom.*;
import org.jxul.util.*;

/**
 * A XUL treechildren element
 */
public class XulTreeChildren 
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }

    //The Element
    private Element treechildrenElement;

    //A treechildren element has a collection of treeitems.
    private Vector treeItems = new Vector();

    // attributes
    String _class;
    String flex;
    String id;
    Hashtable peerMap;

    public XulTreeChildren(Element treechildrenElement, Hashtable peerMap) throws XulFormatException
    {
        this.treechildrenElement = treechildrenElement; 
	this.peerMap = peerMap;

        Attr _classAttr = treechildrenElement.getAttributeNode(XulSyntax.TABS_ATTR_CLASS);
        Attr flexAttr = treechildrenElement.getAttributeNode(XulSyntax.TABS_ATTR_FLEX);
        Attr idAttr = treechildrenElement.getAttributeNode(XulSyntax.TABS_ATTR_ID);

        processChildren();

    } // end of XulTreeChildren Constructor
        
    public void processChildren() throws XulFormatException
    {
        if (treechildrenElement.hasChildNodes())
        {
            NodeList children = treechildrenElement.getChildNodes();
            int childCount = children.getLength();
	    
            for (int i=0; i < childCount; i++)
            {
                // get the child node
                Node child = children.item(i);
                String childName = child.getNodeName(); 
                if (debug)
                    System.out.println("Child[" + i + "]" +
                    childName + "-" + child.getNodeValue());
 
                // switch on the type of the child
               
		if (childName.equals(XulSyntax.ELEMENT_TREEITEM))
		{
			XulTreeItem ti = new XulTreeItem((Element)child, peerMap);
			peerMap.put(child, ti); 
			treeItems.add(ti);
		}
		else
		{
			System.out.println("*TBD* - process " + childName);
		} 
            } // end of for (all children)
        } // end of if (children exist)                       
    }

    /*
     * used by treetable.XulTreeModel
     */
    public Vector getItems()
    {
	return (treeItems);
    }
    /** for unit testing. */
    public static void main(String args[])
    {
        try
        {
            
        } catch (Throwable t)
          {
            t.printStackTrace();
          }
    }
}
